
// I N C L U D E S ///////////////////////////////////////////////////////////

#include <kos.h>

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>

#include <dc/video.h>
#include "graph.h"



  // size of tile (wall height)
#define TILE_SIZE  64
#define WALL_HEIGHT  64
#define EYE_HEIGHT  32
#define PROJECTIONPLANEWIDTH  640
#define PROJECTIONPLANEHEIGHT  400
#define ANGLE60  PROJECTIONPLANEWIDTH
#define ANGLE30  (ANGLE60/2)
#define ANGLE15  (ANGLE30/2)
#define ANGLE45  (ANGLE15*3)
#define ANGLE90  (ANGLE30*3)
#define ANGLE180  (ANGLE90*2)
#define ANGLE225  (ANGLE15*15)
#define ANGLE270  (ANGLE90*3)
#define ANGLE360  (ANGLE60*6)
#define ANGLE0  0
#define ANGLE5  (ANGLE30/6)
#define ANGLE10  (ANGLE5*2)
#define W  1
#define O  0
#define MAP_WIDTH  64
#define MAP_HEIGHT  64
#define OVERBOARD 32


extern uint8 romdisk[];
KOS_INIT_ROMDISK(romdisk);


  // trigonometric tables
  float fSinTable[ANGLE360+1];
  float fISinTable[ANGLE360+1];
  float fCosTable[ANGLE360+1];
  float fICosTable[ANGLE360+1];
  float fTanTable[ANGLE360+1];
  float fITanTable[ANGLE360+1];
  float fFishTable[ANGLE360+1];
  float fXStepTable[ANGLE360+1];
  float fYStepTable[ANGLE360+1];
  
  float zbuffer[650];



  // player's attributes
  int dragonx[5];
  int dragony[5];
  int objectx[5];
  int objecty[5];
  int item=255;           //what the player is holding
  int release=0;

  int fPlayerX = 100;
  int fPlayerY = 160;
  int fPlayerArc = ANGLE0;
  int fPlayerDistanceToTheProjectionPlane = 277;
  int fPlayerHeight =32;
  int fPlayerSpeed = 16;
  int fProjectionPlaneYCenter = PROJECTIONPLANEHEIGHT/2;
  // the following variables are used to keep the player coordinate in the overhead map
  int fPlayerMapX, fPlayerMapY, fMinimapWidth;

char world[MAP_WIDTH][MAP_HEIGHT];

        uint32 flipper=0xa500000;


        uint16 dragonpal[5][260*2];
unsigned char dragon[5][64*64+128];
        uint16 objectpal[5][260*2];
unsigned char object[5][64*64+128];
        uint16 wallpal[10][260*2];
unsigned char wall[10][64*64+128];
        uint16 skypal[260*2];
unsigned char sky[3840*200+128];



// F U N C T I O N S /////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void Load_World(char *file)
{
// this function opens the input file and loads the world data from it

FILE  *fp, *fopen();
int row,column;
char ch;
if (!(fp = fopen(file,"r")))
   return(0);
for (row=0; row<MAP_WIDTH; row++)
    {
    // load in the next row

    for (column=0; column<MAP_HEIGHT; column++)
        {
        while((ch = fgetc(fp))<14){} // filter out CR
        if (ch == ' ')
           ch=0;
        else
           ch = ch - '0';
        world[row][column] = ch;
        //world[(MAP_WIDTH-1) - row][column] = ch;
         //    x     y
        } // end for column
    } // end for row

fclose(fp);

return(1);
        }//end load world
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////        }
//////////////////////////////////////////////////////////////////////////////
//flood fill cieling and floor
void drawbck(int start){
	uint32 *dblpixel=flipper+256000;
	uint16 *pixel=flipper;
	uint32 i,j,k;


for(i=0; i<=64000; i++){
*dblpixel=0x21082108;
*dblpixel++;
}

for(i=0;i<198;i++){
   k=0;
   for(j=0;j<640;j++){
   pixel[(i*640)+j]=skypal[sky[(i*3840)+(start+k)]];
   k++;
   }
}


}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//plot a pixel (base function to draw a dot to the screen)
//Plots to 1 of 2 buffers $A51 and $A50 dependant on Global "flipper"
//rewritten to use shl inst. instead of Mult executes 20% faster
//remeber to change flipper to 0x0100000 or 0x0000000 and just or
//it with pixel.. will save about 6 inst. per loop

inline void draw_pixel( unsigned int x, unsigned int y, uint16 colour )
{
	uint16 *pixel;
	if(x>1 && x<639){
        if(y>1 && y<479){
		
	pixel = ((uint16 *)flipper)+((y<<9)+(y<<7));

	//pixel = ((unsigned short*)0xa5100000)+(640*y);
	//pixel = ((unsigned short*)0xa5000000)+((y<<9)+(y<<7));
	//pixel = ((unsigned short*)0xa5000000)+(640*y);

	pixel[x] = colour;
}
 }}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//Draw a "Filled" rectangle

void draw_filledsquare( unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short color )
{
	unsigned int x, y;
	unsigned int gx, lx, gy, ly;

	gy = ( y1 > y2 ) ? y1 : y2;
	ly = ( y1 > y2 ) ? y2 : y1;
	gx = ( x1 > x2 ) ? x1 : x2;
	lx = ( x1 > x2 ) ? x2 : x1;

	for(x=lx; x<=gx; x++){

		for(y=ly; y<=gy; y++){

			draw_pixel(x, y, color);

}
}
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//Draw a line uses simple Y=mX+B

void draw_line( unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short colour ) 
{
	unsigned int greater, lesser;	/* greater x and lesser x */
	unsigned int i;
	float m, c;
	
	/* if the x values are the same, theres no gradient, so just loop */
	if( x1 == x2 )
	{
		/* find the greater and lesser y values for looping */
		greater = ( y1 > y2 ) ? y1 : y2;
		lesser = ( y1 > y2 ) ? y2 : y1;

		for( i=lesser; i<=greater; i++ ){
			draw_pixel( x1, i, colour );
			}	

	} else {
		/* find the greater and lesser x values for looping */
		greater = ( x1 > x2 ) ? x1 : x2;
		lesser = ( x1 > x2 ) ? x2 : x1;
		
		/* Calculate m and c for y = mx+c */
		m = ((float)y2 - (float)y1) / ((float)x2 - (float)x1);
		c = y1 - (m * x1);

		//if( m == (y2 - y1) / (x2 - x1) )
		//	return;

		/* loop between x values */
		for( i=lesser; i<=greater; i++ ) 
			draw_pixel( i, m*i+c, colour );
	}
}






//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// Convert arc to radian
  float arcToRad(float arcAngle)
  {
     return ((float)(arcAngle*3.141592654)/(float)ANGLE180);
  }



//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// Create tigonometric values to make the program runs faster.
void createTables()
  {
    int i;
    float radian;

    for (i=0; i<=ANGLE360;i++)
    {
      // get the radian value (the last addition is to avoid division by 0, try removing
          // that and you'll see a hole in the wall when a ray is at 0, 90, 180, or 270 degree)
      radian = arcToRad(i) + (float)(0.0001);
      fSinTable[i]=(float)sin(radian);
      fISinTable[i]=(1.0F/(fSinTable[i]));
      fCosTable[i]=(float)cos(radian);
      fICosTable[i]=(1.0F/(fCosTable[i]));
      fTanTable[i]=(float)tan(radian);
      fITanTable[i]=(1.0F/fTanTable[i]);

        //  you can see that the distance between xi is the same
        //  if we know the angle
        //  _____|_/next xi______________
        //       |
        //  ____/|next xi_________   slope = tan = height / dist between xi's
        //     / |
        //  __/__|_________  dist between xi = height/tan where height=tile size
        // old xi|
        //                  distance between xi = x_step[view_angle];
        //
        //
        // facine left
      // facing left
      if (i>=ANGLE90 && i<ANGLE270)
      {
        fXStepTable[i] = (float)(TILE_SIZE/fTanTable[i]);
        if (fXStepTable[i]>0)
          fXStepTable[i]=-fXStepTable[i];
      }
      // facing right
      else
      {
        fXStepTable[i] = (float)(TILE_SIZE/fTanTable[i]);
        if (fXStepTable[i]<0)
          fXStepTable[i]=-fXStepTable[i];
      }

      // FACING DOWN
      if (i>=ANGLE0 && i<ANGLE180)
      {
        fYStepTable[i] = (float)(TILE_SIZE*fTanTable[i]);
        if (fYStepTable[i]<0)
          fYStepTable[i]=-fYStepTable[i];
      }
      // FACING UP
      else
      {
        fYStepTable[i] = (float)(TILE_SIZE*fTanTable[i]);
        if (fYStepTable[i]>0)
          fYStepTable[i]=-fYStepTable[i];
      }
    }

    for (i=-ANGLE30; i<=ANGLE30; i++)
    {
        radian = arcToRad(i);
        // we don't have negative angle, so make it start at 0
        // this will give range 0 to 320
        fFishTable[i+ANGLE30] = (float)(1.0F/cos(radian));
    }

       // fMap=map;
  }


//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
  void movedragons(void){
   int index;
   for(index=0;index<5;index++){

       if(abs(dragony[index]-fPlayerY)>32){
         if(dragony[index]<fPlayerY)dragony[index]+=index;
         if(dragony[index]>fPlayerY)dragony[index]-=index;
         }
         if(abs(dragonx[index]-fPlayerX)>32){
         if(dragonx[index]<fPlayerX)dragonx[index]+=index;
         if(dragonx[index]>fPlayerX)dragonx[index]-=index;
         }
   }
  }//end movedragons


//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// Main
   void main(void)
  {
  char done=0;
  cont_cond_t cond;
  int x_cell,y_cell,x_sub_cell,y_sub_cell;
   vid_set_mode(3, 0);
   vid_empty();
   createTables();
   pcxload(64,64,&wall[1][0],&wallpal[1][0],"/rd/wall.pcx");
   pcxload(64,64,&wall[3][0],&wallpal[3][0],"/rd/wall3.pcx");
   pcxload(64,64,&wall[5][0],&wallpal[5][0],"/rd/wall5.pcx");
   pcxload(64,64,&wall[7][0],&wallpal[7][0],"/rd/wall7.pcx");
   pcxload(64,64,&wall[9][0],&wallpal[9][0],"/rd/wall9.pcx");
   pcxload(3840,200,sky,skypal,"/rd/sky.pcx");
   pcxload(64,64,&dragon[0][0],&dragonpal[0][0],"/rd/ydragon.pcx");
   pcxload(64,64,&dragon[1][0],&dragonpal[1][0],"/rd/rdragon.pcx");
   pcxload(64,64,&dragon[2][0],&dragonpal[2][0],"/rd/gdragon.pcx");
   pcxload(64,64,&dragon[3][0],&dragonpal[3][0],"/rd/bdragon.pcx");
   pcxload(64,64,&dragon[4][0],&dragonpal[4][0],"/rd/wdragon.pcx");
   pcxload(64,64,&object[0][0],&objectpal[0][0],"/rd/keyy.pcx");
   pcxload(64,64,&object[1][0],&objectpal[1][0],"/rd/keyb.pcx");
   pcxload(64,64,&object[2][0],&objectpal[2][0],"/rd/keyr.pcx");
   Load_World("/rd/level.dat");

   dragonx[0]=100;
   dragony[0]=100;
   dragonx[1]=500;
   dragony[1]=500;
   dragonx[2]=1000;
   dragony[2]=500;
   dragonx[3]=2000;
   dragony[3]=1000;
   dragonx[4]=3000;
   dragony[4]=1000;
   
   objectx[0]=100;
   objecty[0]=100;
   objectx[1]=500;
   objecty[1]=500;
   objectx[2]=1000;
   objecty[2]=500;


    while(!done)
    {

    
    cont_get_cond(maple_first_controller(), &cond);
    
          // rotate left
      if (!(cond.buttons & CONT_DPAD_LEFT))
      {
        if ((fPlayerArc-=ANGLE5)<ANGLE0)
          fPlayerArc+=ANGLE360;
      }
          // rotate right
      else if (!(cond.buttons & CONT_DPAD_RIGHT))
      {
        if ((fPlayerArc+=ANGLE5)>=ANGLE360)
          fPlayerArc-=ANGLE360;
      }

          //  _____     _
          // |\ arc     |
          // |  \       y
          // |    \     |
      //            -
          // |--x--|
          //
          //  sin(arc)=y/diagonal
          //  cos(arc)=x/diagonal   where diagonal=speed
      float playerXDir=fCosTable[fPlayerArc];
      float playerYDir=fSinTable[fPlayerArc];

          // move forward
      if (!(cond.buttons & CONT_DPAD_UP))
      {
        fPlayerX+=(int)(playerXDir*fPlayerSpeed);
        fPlayerY+=(int)(playerYDir*fPlayerSpeed);
      }
          // move backward
      else if (!(cond.buttons & CONT_DPAD_DOWN))
      {
        fPlayerX-=(int)(playerXDir*fPlayerSpeed);
        fPlayerY-=(int)(playerYDir*fPlayerSpeed);
      }
      if (!(cond.buttons & CONT_START))
      {
      done=1;
      }

        // compute cell position

        x_cell = fPlayerX/MAP_WIDTH;
        y_cell = fPlayerY/MAP_HEIGHT;

        // compute position relative to cell

        x_sub_cell = fPlayerX % TILE_SIZE;
        y_sub_cell = fPlayerY % TILE_SIZE;


        // resolve motion into it's x and y components

        if (playerXDir>0 )
           {
           // moving right

            if ( (world[x_cell+1][y_cell] != 0)  &&
                (x_sub_cell > (TILE_SIZE-OVERBOARD ) ) )
                {
                // back player up amount he steped over the line

                fPlayerX-= (x_sub_cell-(TILE_SIZE-OVERBOARD ));

                } // end if need to back up
           }
        else
           {
           // moving left

          if ( (world[x_cell-1][y_cell] != 0)  &&
                (x_sub_cell < (OVERBOARD) ) )
                {
                // back player up amount he steped over the line

                fPlayerX+= (OVERBOARD-x_sub_cell) ;

                } // end if need to back up

           } // end else
        if (playerYDir>0 )
           {
           // moving up

         
           if ( (world[x_cell][(y_cell+1)] != 0)  &&
                (y_sub_cell > (TILE_SIZE-OVERBOARD ) ) )
                {
                // back player up amount he steped over the line

                fPlayerY-= (y_sub_cell-(TILE_SIZE-OVERBOARD ));

                } // end if need to back up
           }
        else
           {
           // moving down

            if ( (world[x_cell][(y_cell-1)] != 0)  &&
                (y_sub_cell < (OVERBOARD) ) )
                {
                // back player up amount he steped over the line

                fPlayerY+= (OVERBOARD-y_sub_cell);

                } // end if need to back up

              }


         
          drawbck(fPlayerArc);
          render();
          drawmap();
          movedragons();
          drawdragon();
          drawobject();
          if((!(cond.buttons & CONT_A)) && release==0)objcollision();
          
          if(release==1 && (cond.buttons & CONT_A))
		{
		release=0;
		}

	//Double buffer flip

	if(flipper==0xa5100000){
		 vid_waitvbl(); 
		vid_set_start(0x100000);
		flipper=0xa5000000;
		}
	else{
		vid_waitvbl(); 
		vid_set_start(0);
		flipper=0xa5100000;
	}



    }
  }//end main


  //*******************************************************************//
  //* Draw map on the right side
  //*******************************************************************//
// draw 2-D map of world

void drawmap(void)
{
int row,column,block,x_cell,y_cell;

for (row=0; row<MAP_WIDTH; row++)
   {
   for (column=0; column<MAP_HEIGHT; column++)
       {

       block = world[column][row];
       //world[(MAP_WIDTH-1) - row][column] = ch;
       // test if there is a solid block there

       if (block==0)
          {
          draw_filledsquare(column*TILE_SIZE/32,row*TILE_SIZE/32,
                        column*TILE_SIZE/32+TILE_SIZE/32-1,row*TILE_SIZE/32+TILE_SIZE/32-1,0xaaaa);
          }
       else
          {
          draw_filledsquare(column*TILE_SIZE/32,row*TILE_SIZE/32,
                        column*TILE_SIZE/32+TILE_SIZE/32-1,row*TILE_SIZE/32+TILE_SIZE/32-1,0xf800);

          }

       } // end for column

   } // end for row


        x_cell = fPlayerX/MAP_WIDTH;
        y_cell = fPlayerY/MAP_HEIGHT;

        draw_pixel(  x_cell*2, y_cell*2, 0xffff );
        draw_pixel( (x_cell*2)+1, y_cell*2, 0xffff );

         x_cell = dragonx[0]/MAP_WIDTH;
        y_cell = dragony[0]/MAP_HEIGHT;

        draw_pixel(  x_cell*2, y_cell*2, 0xcccc );
        draw_pixel( (x_cell*2)+1, y_cell*2, 0xcccc );


} // end Draw_2D_Map




//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void render()
  {



    int verticalGrid;        // horizotal or vertical coordinate of intersection
    int horizontalGrid;      // theoritically, this will be multiple of TILE_SIZE
                             // , but some trick did here might cause
                             // the values off by 1
    int distToNextVerticalGrid; // how far to the next bound (this is multiple of
    int distToNextHorizontalGrid; // tile size)
    float xIntersection;  // x and y intersections
    float yIntersection;


    float distToNextXIntersection;
    float distToNextYIntersection;

    int xGridIndex;        // the current cell that the ray is in
    int yGridIndex;

    float distToVerticalGridBeingHit;      // the distance of the x and y ray intersections from
    float distToHorizontalGridBeingHit;      // the viewpoint

    int projectedWallHeight;
    int castArc, castColumn;
    short color=0x0000;

    float y_scale_index,x_scale_step,y_scale_step,x_scale_index;
    int offset;
    long i,texline,k,l;
    uint16 *buffer;
    unsigned int walltype,xwalltype,ywalltype,mirror;


    castArc = fPlayerArc;
        // field of view is 60 degree with the point of view (player's direction in the middle)
        // 30  30
        //    ^
        //  \ | /
        //   \|/
        //    v
        // we will trace the rays starting from the leftmost ray
        castArc-=ANGLE30;
        // wrap around if necessary
    if (castArc < 0)
    {
      castArc=ANGLE360 + castArc;
    }

    for (castColumn=0; castColumn<PROJECTIONPLANEWIDTH; castColumn++)
    {

          // ray is between 0 to 180 degree (1st and 2nd quadrant)
          // ray is facing down
      if (castArc > ANGLE0 && castArc < ANGLE180)
      {
                // truncuate then add to get the coordinate of the FIRST grid (horizontal
                // wall) that is in front of the player (this is in pixel unit)
                // ROUND DOWN
        horizontalGrid = (fPlayerY/TILE_SIZE)*TILE_SIZE  + TILE_SIZE;

        // compute distance to the next horizontal wall
        distToNextHorizontalGrid = TILE_SIZE;

        float xtemp = fITanTable[castArc]*(horizontalGrid-fPlayerY);
                // we can get the vertical distance to that wall by
                // (horizontalGrid-GLplayerY)
                // we can get the horizontal distance to that wall by
                // 1/tan(arc)*verticalDistance
                // find the x interception to that wall
        xIntersection = xtemp + fPlayerX;
      }
      // else, the ray is facing up
      else
      {
        horizontalGrid = (fPlayerY/TILE_SIZE)*TILE_SIZE;
        distToNextHorizontalGrid = -TILE_SIZE;

        float xtemp = fITanTable[castArc]*(horizontalGrid - fPlayerY);
        xIntersection = xtemp + fPlayerX;

        horizontalGrid--;
      }
          // LOOK FOR HORIZONTAL WALL
      if (castArc==ANGLE0 || castArc==ANGLE180)
      {
        distToHorizontalGridBeingHit=99999999.0f;//Float.MAX_VALUE;
      }
      // else, move the ray until it hits a horizontal wall
      else
      {
        distToNextXIntersection = fXStepTable[castArc];
        while (true)
        {
          xGridIndex = (int)(xIntersection/TILE_SIZE);
          // in the picture, yGridIndex will be 1
          yGridIndex = (horizontalGrid/TILE_SIZE);

          if ((xGridIndex>=MAP_WIDTH) ||
            (yGridIndex>=MAP_HEIGHT) ||
            xGridIndex<0 || yGridIndex<0)
          {
            distToHorizontalGridBeingHit = 99999999.0f;
            break;
          }
          else if ((world[xGridIndex][yGridIndex])!=0)
          {
            distToHorizontalGridBeingHit  = (xIntersection-fPlayerX)*fICosTable[castArc];
            xwalltype=world[xGridIndex][yGridIndex];
            break;
          }
          // else, the ray is not blocked, extend to the next block
          else
          {
            xIntersection += distToNextXIntersection;
            horizontalGrid += distToNextHorizontalGrid;
          }
        }
      }


      // FOLLOW X RAY
      if (castArc < ANGLE90 || castArc > ANGLE270)
      {
        verticalGrid = TILE_SIZE + (fPlayerX/TILE_SIZE)*TILE_SIZE;
        distToNextVerticalGrid = TILE_SIZE;

        float ytemp = fTanTable[castArc]*(verticalGrid - fPlayerX);
        yIntersection = ytemp + fPlayerY;
      }
      // RAY FACING LEFT
      else
      {
        verticalGrid = (fPlayerX/TILE_SIZE)*TILE_SIZE;
        distToNextVerticalGrid = -TILE_SIZE;

        float ytemp = fTanTable[castArc]*(verticalGrid - fPlayerX);
        yIntersection = ytemp + fPlayerY;

        verticalGrid--;
      }
          // LOOK FOR VERTICAL WALL
      if (castArc==ANGLE90||castArc==ANGLE270)
      {
        distToVerticalGridBeingHit =99999999.0f;//Float.MAX_VALUE;
      }
      else
      {
        distToNextYIntersection = fYStepTable[castArc];
        while (true)
        {
          // compute current map position to inspect
          xGridIndex = (verticalGrid/TILE_SIZE);
          yGridIndex = (int)(yIntersection/TILE_SIZE);

          if ((xGridIndex>=MAP_WIDTH) ||
            (yGridIndex>=MAP_HEIGHT) ||
            xGridIndex<0 || yGridIndex<0)
          {
            distToVerticalGridBeingHit =99999999.0f;
            break;
          }
          else if ((world[xGridIndex][yGridIndex])!=0)
          {
            distToVerticalGridBeingHit =(yIntersection-fPlayerY)*fISinTable[castArc];
            ywalltype=world[xGridIndex][yGridIndex];

            break;
          }
          else
          {
          	

            yIntersection += distToNextYIntersection;
            verticalGrid += distToNextVerticalGrid;
          }
        }
      }

          // DRAW THE WALL SLICE
          float scaleFactor;
          float dist;
      int topOfWall;   // used to compute the top and bottom of the sliver that
      int bottomOfWall;   // will be the staring point of floor and ceiling
      // determine which ray strikes a closer wall.
      // if yray distance to the wall is closer, the yDistance will be shorter than
          // the xDistance
      if (distToHorizontalGridBeingHit < distToVerticalGridBeingHit)
          {
                // the next function call (drawRayOnMap()) is not a part of raycating rendering part, 
                // it just draws the ray on the overhead map to illustrate the raycasting process
           // drawRayOnOverheadMap(xIntersection, horizontalGrid);
        dist=distToHorizontalGridBeingHit;
        texline=(long)xIntersection%64;
        walltype=xwalltype;
        //fOffscreenGraphics.setColor(Color.gray);
      //  color=0x5555;
      }
      // else, we use xray instead (meaning the vertical wall is closer than
      //   the horizontal wall)
          else
          {
                // the next function call (drawRayOnMap()) is not a part of raycating rendering part,
                // it just draws the ray on the overhead map to illustrate the raycasting process
            //drawRayOnOverheadMap(verticalGrid, yIntersection);
        dist=distToVerticalGridBeingHit;
        texline=(long)yIntersection%64;
        walltype=ywalltype;
        //fOffscreenGraphics.setColor(Color.darkGray);
       // color=0xaaaa;
          }

        //if (castArc>=ANGLE45 && castArc<=ANGLE225)mirror=63;
        //if (castArc>=ANGLE90 && castArc<ANGLE180)mirror=63;
        //if (castArc>=ANGLE180 && castArc<ANGLE270)mirror=63;
        //if (castArc>=ANGLE270 && castArc<ANGLE360)mirror=63;
        //if (castArc>=ANGLE180 || castArc<ANGLE270)mirror=63;
        //if(mirror!=0)texline=mirror-(int)texline;
          // correct distance (compensate for the fishbown effect)
      
      zbuffer[castColumn]=dist;
      dist /= fFishTable[castColumn];

         
          // projected_wall_height/wall_height = fPlayerDistToProjectionPlane/dist;

      projectedWallHeight=(int)(WALL_HEIGHT*(float)fPlayerDistanceToTheProjectionPlane/dist);

      bottomOfWall = fProjectionPlaneYCenter+(int)(projectedWallHeight*0.5F);

      topOfWall = PROJECTIONPLANEHEIGHT-bottomOfWall;


          y_scale_step = 64.0f/projectedWallHeight;
           y_scale_index = 0;

          if (projectedWallHeight>PROJECTIONPLANEHEIGHT){
          topOfWall=abs(topOfWall);
          y_scale_index = y_scale_step*(float)topOfWall;
          topOfWall=1;
          projectedWallHeight=PROJECTIONPLANEHEIGHT-1;
          }

         //if (bottomOfWall>=PROJECTIONPLANEHEIGHT)bottomOfWall=PROJECTIONPLANEHEIGHT-1;

          //draw_line(castColumn, topOfWall, castColumn, bottomOfWall,color);



        buffer =(uint16*)(flipper)+((topOfWall*640))+(castColumn);


         //printf("%d,%f,   ",y_scale_step,y_scale_step);

        for(i=0;i<projectedWallHeight;i++){
        *buffer=wallpal[walltype][wall[walltype][offset+texline]];
        buffer+=640;
        y_scale_index+=y_scale_step;
        offset =64*((int)y_scale_index);
        }



          //fOffscreenGraphics.fillRect(castColumn, topOfWall, 5, projectedWallHeight);

          // TRACE THE NEXT RAY
          castArc+=1;
          if (castArc>=ANGLE360)
                castArc-=ANGLE360;
    }


        // blit to screen

  }

  
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
  void drawdragon(void){
  int shiftx,shifty,column;
  int bottomofsprite,topofsprite;
  int newX,newY,x,y;
  int screenX;
  float angle;
  uint16 *buffer;
  float y_scale_index,x_scale_step,y_scale_step,x_scale_index;
  int offset,offset2,spritewidth,index;


  for(index=0;index<5;index++){
  //shift player to 0,0 by moving dragons
  shiftx=dragonx[index]-fPlayerX;
  shifty=dragony[index]-fPlayerY;

  newX = ((float)shiftx*fCosTable[fPlayerArc]) + ((float)shifty*fSinTable[fPlayerArc]);
  newY = ((float)shifty*fCosTable[fPlayerArc]) - ((float)shiftx*fSinTable[fPlayerArc]);


  column = (( 640 * newY )/newX)+320;


 //printf("X:%d,  Y:%d  SX:%d, column:%d  angle:%f  \n",newX,newY,screenX,column,angle);

      int spriteheight=(int)(64*(float)fPlayerDistanceToTheProjectionPlane/newX);
      spritewidth=spriteheight;
      bottomofsprite = fProjectionPlaneYCenter+(int)(spriteheight*0.5F);
      topofsprite = PROJECTIONPLANEHEIGHT-bottomofsprite;
      y_scale_step = 64.0f/spriteheight;
      y_scale_index = 0;
      x_scale_step = 64.0f/spriteheight;
      x_scale_index = 0;


      column=column-(spritewidth/2);
      offset=0;
      offset2=0;

         if (spriteheight>PROJECTIONPLANEHEIGHT){
          topofsprite=abs(topofsprite);
          x_scale_index = x_scale_step*(float)topofsprite;
          topofsprite=1;
          spriteheight=PROJECTIONPLANEHEIGHT-1;
          }



     if(newX>28){
    for (y=0; y<spriteheight; y++)
    {
     x_scale_index=0;

    for (x=0; x<spritewidth; x++)
        {
        buffer =(uint16*)(flipper)+((topofsprite*640))+(column+x);
        if(zbuffer[column+x]>newX && dragon[index][offset+(int)x_scale_index]!=0 && (column+x>1 && column+x<640))
        *buffer=dragonpal[index][dragon[index][offset+(int)x_scale_index]];

        x_scale_index+=(x_scale_step);
        } // end for x
        topofsprite++;
        y_scale_index+=y_scale_step;
        offset = 64*(int)(y_scale_index);

    } // end for y

      } //end newX

        }//end index

  }//end drawdragon
  
  
    
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
  void drawobject(void){
  int shiftx,shifty,column;
  int bottomofsprite,topofsprite;
  int newX,newY,x,y;
  int screenX;
  float angle;
  uint16 *buffer;
  float y_scale_index,x_scale_step,y_scale_step,x_scale_index;
  int offset,offset2,spritewidth,index;


  for(index=0;index<3;index++){
  //shift player to 0,0 by moving dragons
  shiftx=objectx[index]-fPlayerX;
  shifty=objecty[index]-fPlayerY;

  newX = ((float)shiftx*fCosTable[fPlayerArc]) + ((float)shifty*fSinTable[fPlayerArc]);
  newY = ((float)shifty*fCosTable[fPlayerArc]) - ((float)shiftx*fSinTable[fPlayerArc]);


  column = (( 640 * newY )/newX)+320;


 //printf("X:%d,  Y:%d  SX:%d, column:%d  angle:%f  \n",newX,newY,screenX,column,angle);

      int spriteheight=(int)(64*(float)fPlayerDistanceToTheProjectionPlane/newX)/2;
      //if(spriteheight>64)spriteheight=64;
      spritewidth=spriteheight;
      bottomofsprite = fProjectionPlaneYCenter+(int)(spriteheight*0.5F);
      topofsprite = PROJECTIONPLANEHEIGHT-bottomofsprite;
      y_scale_step = 64.0f/spriteheight;
      y_scale_index = 0;
      x_scale_step = 64.0f/spriteheight;
      x_scale_index = 0;


      column=column-(spritewidth/2);
      offset=0;
      offset2=0;

         if (spriteheight>PROJECTIONPLANEHEIGHT){
          topofsprite=abs(topofsprite);
          x_scale_index = x_scale_step*(float)topofsprite;
          topofsprite=1;
          spriteheight=PROJECTIONPLANEHEIGHT-1;
          }



     if(newX>16){
    for (y=0; y<spriteheight; y++)
    {
     x_scale_index=0;

    for (x=0; x<spritewidth; x++)
        {
        buffer =(uint16*)(flipper)+((topofsprite*640))+(column+x);
        if(zbuffer[column+x]>newX && object[index][offset+(int)x_scale_index]!=0 && (column+x>1 && column+x<640))
        *buffer=objectpal[index][object[index][offset+(int)x_scale_index]];

        x_scale_index+=(x_scale_step);
        } // end for x
        topofsprite++;
        y_scale_index+=y_scale_step;
        offset = 64*(int)(y_scale_index);

    } // end for y

      } //end newX

        }//end index

  }//end drawdragon
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void objcollision(void){
    int index;
    int itempresent=255;

  for(index=0;index<3;index++){ //scan for items around player

  if(abs(objectx[index]-fPlayerX)<=64){
         if(abs(objecty[index]-fPlayerY)<=64){ //swap item
           itempresent=index;
  }
  }
  }//end for

  if(itempresent!=255  && item !=255){ //perform a swap
            objectx[item]=objectx[itempresent];
            objecty[item]=objecty[itempresent];
            item=itempresent;
            objectx[itempresent]=0;
            objecty[itempresent]=0;
        }
  else if(itempresent==255  && item !=255){//perform a drop
            objectx[item]=fPlayerX;
            objecty[item]=fPlayerY;
            item=255;
    }
    else if(itempresent!=255  && item ==255){//perform a get
            objectx[itempresent]=0;
            objecty[itempresent]=0;
            item=itempresent;
     }
    release=1; //key debounce

    }//end obj collision


